/**
*	dhcp.c
*	DHCPNCAg(AvP[Vw:RFC1541)
*	Copyright (c)Junnichi Tomaru
*/
#include	"remoir.h"

byte	dhcp_msgtype;	/* bZ[W^Cv */
dword	dhcp_netmask;	/* lbg}XN */
dword	dhcp_gateway;	/* Q[gEFC */
dword	dhcp_server;	/* DHCPT[o */
dword	dhcp_xid;	/* gUNVID */

/**
*	DHCP pPbgM
*	 in	Ȃ
*	out	Ȃ
*/
void	dhcp_discover( SOCKET sn )
{
	byte	*p;
	ul_t	ultmp;

	dhcp_mode = DHCP_DISCOVER;

	ultmp.bytes.hh = 0;
	ultmp.bytes.hl = mac_address[3];	/* gUNVID̐ */
	ultmp.bytes.lh = mac_address[4];	/* Ƃ̂h߁AMACAhX */
	ultmp.bytes.ll = mac_address[5];	/* ̃m[hIDƃ^C}l킹 */

	dhcp_xid = ultmp.data + getcount1ms( );

	p = (byte *)TXBUF;
	*p++ = BOOTP_BOOTREQ;	/* u[gv */
	*p++ = BOOTP_HWADDR;	/* n[hAhX */
	*p++ = BOOTP_HWSIZE;	/* n[hAhX */
	*p++ = 0;		/* zbvJEg */
	setlongvalue( p, dhcp_xid );	/* gUNVhc */
	p += 4;
	setwordvalue( p, 0U );	/* b */
	p += 2;
	setwordvalue( p, 0x8000 );	/* tO(u[hLXg) */
	p += 2;
	memset( p, 0, 16 );	/* `Q[gEFChoAhX */
	p += 16;
	memcpy( p, mac_address, PHYSICALADDR_SIZE );/* MACAhX */
	p += PHYSICALADDR_SIZE;
	memset( p, 0, 202 );	/* c10+T[o[zXg,Nt@C */
	p += 202;
	setlongvalue( p, BOOTP_MAGICCODE );	/* }WbNR[h */
	p += 4;
	setthreevalue( p, BOOTP_DISCOVER );	/* fBXJo[ */
	p += 3;
	*p++ = DHCP_CLIANTID;	/* NCAghc */
	*p++ = DHCP_CLIANTIDLEN;
	*p++ = 1;		/* n[hEFA^Cv */
	memcpy( p, mac_address, PHYSICALADDR_SIZE );
	p += PHYSICALADDR_SIZE;
	*p++ = BOOTP_MSGSTOPPER;	/* Xgbp[ */
	memset( p, 0, 47 );		/* cOŖ߂ */
	sendto( sn, (byte *)TXBUF, DHCPMSG_SIZE, IP_BROADCAST, BOOTPS_PORT );/* M */
}


/**
*	DHCP vpPbgM
*	 in	[h
*	out	Ȃ
*/
void	dhcp_request( SOCKET sn, char mode )
{
	byte	cnt, *p, *q;
	ul_t	ultmp;
	ui_t	uitmp;
	dword	paddr;

	dhcp_mode = DHCP_REQUEST;
	paddr = ( mode != DHCP_RENEWING )? IP_BROADCAST: dhcp_server;
	if( mode != DHCP_REQUEST ){
		ultmp.bytes.hh = 0;
		ultmp.bytes.hl = mac_address[3];/* gUNVhc̐ */
		ultmp.bytes.lh = mac_address[4];/* Ƃ̂h߁AMACAhX */
		ultmp.bytes.ll = mac_address[5];/* ̃m[hhcƃ^C}l킹 */
		dhcp_xid = ultmp.data + getcount1ms( );
	}

	p = (byte *)TXBUF;
	*p++ = BOOTP_BOOTREQ;	/* u[gv */
	*p++ = BOOTP_HWADDR;	/* n[hAhX */
	*p++ = BOOTP_HWSIZE;	/* n[hAhX */
	*p++ = 0;		/* zbvJEg */
	setlongvalue( p, dhcp_xid );	/* gUNVhc(pPbgƓ) */
	p += 4;
	setwordvalue( p, 0U );	/* b */
	p += 2;
	if( mode == DHCP_RENEWING ){
		setwordvalue( p, 0x0000 );	/* tO(jLXg) */
	}
	else{
		setwordvalue( p, 0x8000 );	/* tO(u[hLXg) */
	}
	p += 2;
	setlongvalue( p, myipaddr );	/* NCAghoAhX */
	p += 4;
	memset( p, 0, 12 );		/* 蓖ā`Q[gEFChoAhX */
	p += 12;
	memcpy( p, mac_address, PHYSICALADDR_SIZE );	/* MACAhX */
	p += PHYSICALADDR_SIZE;
	memset( p, 0, 202 );	/* c10+T[o[zXg,Nt@C */
	p += 202;
	setlongvalue( p, BOOTP_MAGICCODE );	/* }WbNR[h */
	p += 4;
	setthreevalue( p, BOOTP_REQUEST );	/* NGXg */
	p += 3;
	*p++ = DHCP_HOSTNAME;	/* zXg */
	*p++ = strlen( host_name );
	memcpy( p, host_name, strlen( host_name ));
	p += strlen( host_name );
	if( mode == DHCP_REQUEST ){
		*p++ = DHCP_REQIPADDR;	/* NGXghoAhX */
		*p++ = DHCP_REQIPADDRLEN;
		q = (byte *)RXBUF + DHCPMSG_USRADDR;
		memcpy( p, q, 4 );	/* [U[hoAhX */
		p += 4;
		*p++ = DHCP_SERVERID;	/* T[ohc */
		*p++ = DHCP_SERVERIDLEN;
		setlongvalue( p, dhcp_server );
		p += 4;
		cnt = 30;
	}
	else{
		cnt = 42;
	}
	*p++ = DHCP_PRMREQLIST;	/* p[^NGXg */
	*p++ = DHCP_PRMREQLISTLEN;
	*p++ = DHCP_SUBNETMASK;	/* lbg}XN */
	*p++ = DHCP_ROUTER;	/* [^ */
	*p++ = DHCP_LEASETIME;	/* [X */
	*p++ = DHCP_CLIANTID;	/* NCAghc */
	*p++ = DHCP_CLIANTIDLEN;
	*p++ = 1;		/* n[hEFA^Cv */
	memcpy( p, mac_address, PHYSICALADDR_SIZE );	/* MACAhX */
	p += PHYSICALADDR_SIZE;
	*p++ = BOOTP_MSGSTOPPER;	/* Xgbp[ */
	cnt -= ( strlen( host_name ) - 2 );	/* zXg */
	memset( p, 0, cnt );	/* cOŖ߂ */
	sendto( sn, (byte *)TXBUF, DHCPMSG_SIZE, paddr, BOOTPS_PORT );
}


/**
*	x_[dľ
*	 in	Ȃ
*	out	TRUE:IvVnj FALSE:Ƃ낪(Ȃ)
*/
bool	dhcp_searchoption( void )
{
	byte	d, i, *p;
	bool	ret;
	dword	dw;

	p = (byte *)RXBUF + BOOTPMAIN_SIZE + 4;	/* IvV擪 */
	ret = FALSE;
	while( ret == FALSE ){
		d = *p++;	/* R[h */
		if( d == DHCP_MESSAGETYPE ){	/* bZ[W̎ */
			if( *p++ == DHCP_MESSAGETYPELEN ){
				dhcp_msgtype = *p++;
			}
			else{
				goto END;
			}
		}
		else if( d == DHCP_SUBNETMASK ){	/* Tulbg}XN */
			if( *p++ == DHCP_SUBNETMASKLEN ){
				dhcp_netmask = getlongvalue( p );
				p += 4;
			}
			else{
				goto END;
			}
		}
		else if( d == DHCP_ROUTER ){	/* [^ */
			d = *p++;	/*  */
			if( d >= DHCP_ROUTERLEN ){
				dhcp_gateway = getlongvalue( p );
				p += 4;
				d -= DHCP_ROUTERLEN;
				if( d != 0 ){
					p += d;
				}
			}
			else{
				goto END;
			}
		}
		else if( d == DHCP_SERVERID ){	/* DHCPT[o */
			if( *p++ == DHCP_SERVERIDLEN ){
				dhcp_server = getlongvalue( p );
				p += 4;
			}
			else{
				goto END;
			}
		}
		else if( d == BOOTP_MSGSTOPPER ){	/* I[ */
			ret = TRUE;
		}
		else if( d == DHCP_LEASETIME ){	/* [X */
			if( *p++ == DHCP_LEASETIMELEN ){
				lease_time = dw = getlongvalue( p );
				p += 4;
				dhcp_t2 = (dword)( dw * 875L / 1000L );
				/* [XԂ87.5%REBIND(T2) */
				dhcp_t1 = dw >> 1;	/* 1/2 */
				/* [XԂ50%RENEWAL(T1) */
			}
		}
		else{	/* ֌WȂ͓̂ǂݔ΂ */
			d = *p++;	/*  */
			p += d;	/* ǂݔ΂ */
		}
	}
END:
	return	ret;
}


/**
*	DHCPm菈
*	 in	Ȃ
*	out	Ȃ
*/
void	dhcp_ackseq( void )
{
	char	buf[16];
	byte	*p;

	p = (byte *)RXBUF + DHCPMSG_USRADDR;	/* [UIPAhXʒu */
	dhcp_mode = DHCP_BOUND;
	myipaddr = getlongvalue( p );
	netmask = dhcp_netmask;
	gateway = dhcp_gateway;
	set_srcipaddr( myipaddr );	/* IPAhX */
	set_netmask( netmask );		/* lbg}XN */
	set_gateway( gateway );		/* Q[gEFC */
	lcdlcls( 0 );
	inet_ntoa( myipaddr, buf );
	lcdprint( 0, 0, buf );
	if( lease_time == 0xffffffff ){
		lcdspace( 10, 1, 6 );
		lcdprint( 12, 1, "INF." );
	}
	else{
		dhcpcnten = on;
		start_dhcpcnt( );
		dispcounter( CNT_REM );
	}
}


/**
*	DHCP͏
*	 in	Ȃ
*	out	Ȃ
*/
void	dhcp_input( SOCKET sn )
{
	dword	tid;

	if(( dhcp_mode == DHCP_ABORT ) || ( dhcp_mode == DHCP_BOUND )){
		return;
	}
	if( dhcp_searchoption( ) == FALSE ){	/* IvV */
		myipaddr = netmask = gateway = 0;
		dhcp_discover( sn );		/* Ȃ */
		return;
	}
	tid = getlongvalue((byte *)RXBUF + DHCPMSG_TRID );	/* gUNVID */
	if(( dhcp_mode == DHCP_DISCOVER ) && ( dhcp_msgtype == DHCP_OFFER )){	/* 񋟃pPbgM */
		if( tid == dhcp_xid ){	/* ꍇ̗p */
			dhcp_request( sn, DHCP_REQUEST );
		}
	}
	else if( dhcp_mode == DHCP_REQUEST ){
		if( dhcp_msgtype == DHCP_PACK ){	/* mFm艞 */
			if( tid == dhcp_xid ){	/* ꍇ̗p */
				dhcp_ackseq( );
			}
		}
		else if( dhcp_msgtype == DHCP_PNAK ){	/* mFے艞 */
			if( tid == dhcp_xid ){	/* ꍇ̗p */
				myipaddr = netmask = gateway = 0;
				dhcp_discover( sn );	/* Ȃ */
			}
		}
	}
}


/* end of dhcp.c */
