/**
*	socket.c
*	\Pbg֐Q
*	Copyright (c)Junnichi Tomaru
*/
#include	"socket.h"

static word	local_port;

#define	WAIT_ENDPROCESS(x)	while(getsn_cr(x))

/**
*	w\Pbg̐
*	 in	sn		\Pbgԍ(0-3)
*		protocol	gpvgR
*		port_pn		gp|[gԍ(SOCK_IPRAW̓vgRԍ)
*		opt		Sn_MRWX^IvVtO
*	out	0ȏ:(\Pbgԍ) INVALID_SOCKET:s
*/
SOCKET	socket( SOCKET sn, byte protocol, word port_pn, byte opt )
{
	SOCKET	ret;
	word	wd;
	const	byte sr[] = { 0, SOCK_INIT, SOCK_UDP, SOCK_IPRAW, SOCK_MACRAW, SOCK_PPPOE };

	if(( sn < 0 ) || ( sn > 3 )){
		return	INVALID_SOCKET;
	}
	if (( protocol >= SOCK_STREAM ) && ( protocol <= SOCK_PPPoE )){
		close( sn );		/* xN[Y */
		setsn_mr((char)sn, protocol | opt );	/* vgRݒ */
		if(( protocol == SOCK_STREAM ) || ( protocol == SOCK_DGRAM )){/* TCP,UDP */
			if( port_pn != 0 ){	/* |[gw肪 */
				wd = port_pn;
			}
			else{	/* |[gŵƂ́A[J|[gg */
				local_port++;
				wd = local_port;
			}
			setsn_srcport((char)sn, wd );	/* |[gݒ */
		}
		else if( protocol == SOCK_RAW ){	/* IPRAW */
			setsn_proto((char)sn, (byte)port_pn );
		}
		setsn_cr((char)sn, Sn_CR_OPEN );	/* \Pbg */

		WAIT_ENDPROCESS((char)sn );	/* I҂ */
		if( getsn_sr( (char)sn ) == sr[protocol] ){/* ԂڂmF */
			ret = (int)sn;
		}
		else{
			ret = INVALID_SOCKET;
		}
	}
	else{	/* vgRw肪ԈĂ */
		ret = INVALID_SOCKET;
	}

	return	ret;
}


/**
*	w\PbgN[Y()
*	 in	\Pbgԍ
*	out	0:  SOCKET_ERROR:s
*/
int	close( SOCKET sn )
{
	setsn_cr( sn, Sn_CR_CLOSE );

	WAIT_ENDPROCESS( sn );	/* I҂ */

	/* ---- KvȂ炱CPŮ荞݂~ ---- */
	setsn_ir( sn, 0xff );	/* 荞݃Xe[^XNA */
	if( getsn_sr( sn ) == SOCK_CLOSED ){/* N[YmF */
		return	0;
	}
	else{
		return	SOCKET_ERROR;
	}
}


/**
*	LISTENԂɂ(TCP)
*	 in	\Pbgԍ
*	out	0: SOCKET_ERROR:s
*/ 
int	listen( SOCKET sn )
{
	bool	ret;

	if( getsn_sr( sn ) == SOCK_INIT ){	/* INITXe[gł */
		setsn_cr( sn, Sn_CR_LISTEN );
		WAIT_ENDPROCESS( sn );	/* I҂ */
		if( getsn_sr( sn ) == SOCK_LISTEN ){	/* ԈڂmF */
			ret = 0;
		}
		else{
			ret = SOCKET_ERROR;
		}
	}
	else{
		ret = SOCKET_ERROR;
	}

	return	ret;
}


/**
*	TCPT[oɐڑ
*	 in	sn	\Pbgԍ
*		addr	IPAhX
*		port	̃|[g
*	out	0:  SOCKET_ERROR:s
*/
int	connect( SOCKET sn, dword addr, word port )
{
	bool	ret;

	if(( addr == 0xffffffff ) || ( addr == 0 ) || ( port == 0x00 )){
 		ret = SOCKET_ERROR;
	}
	else{
		setsn_destip((char)sn, addr );	/* IPAhX */
		setsn_destport((char)sn, port );	/* ̃|[g */
		setsn_cr((char)sn, Sn_CR_CONNECT );	/* ڑ */
		WAIT_ENDPROCESS((char)sn );	/* I҂ */
		ret = 0;
	}

	return	ret;
}


/**
*	w\Pbgؒf
*	 in	\Pbgԍ
*	out	0:  SOCKET_ERROR:s
*/ 
int	disconnect( SOCKET sn )
{
	int	ret;

	setsn_cr((char)sn, Sn_CR_DISCON );
	WAIT_ENDPROCESS((char)sn );	/* I҂ */
	if( getsn_sr((char)sn ) == SOCK_CLOSED ){	/* ԈڂmF */
		ret = 0;
	}
	else{
		ret = SOCKET_ERROR;
	}

	return	ret;
}


/**
*	TCPf[^M
*	 in	sn	\Pbgԍ
*		buf	Mf[^obt@
*		len	MTCY
*	out	SOCKET_ERROR:s  ȊO:Mf[^TCY
*/ 
int	send( SOCKET sn, byte *buf, int len )
{
	byte	status;
	int	ret, free, max;

	ret = 0;
	max = socksts[sn].txsize;
	if( len > max ){	/* Mobt@𒴂Ă */
		ret = max;
	}
	else{
		ret = len;
	}
	do{			/* Mobt@󂭂̂҂ */
		free = getsn_tx_fsr((char)sn );
		status = getsn_sr((char)sn );	/* \PbgXe[^X */
		if(( status != SOCK_ESTABLISHED ) && ( status != SOCK_CLOSE_WAIT )){
			return	SOCKET_ERROR;
		}
	} while( free < ret );

	send_data((char)sn, buf, ret );	/* f[^Rs[ */
	WAIT_ENDPROCESS((char)sn );	/* I҂ */

	while( 1 ){	/* MOK҂ */
		if( getsn_ir((char)sn ) & Sn_IR_SEND_OK ){	/* M */
			break;
		}
		if( getsn_sr((char)sn ) == SOCK_CLOSED ){	/* \Pbgؒf */
			close( sn );
			return	SOCKET_ERROR;
		}
  	}
	setsn_ir((char)sn, Sn_IR_SEND_OK );	/* tONA */

	return	ret;
}


/**
*	TCPf[^M
*	 in	sn	\Pbgԍ
*		buf	f[^i[obt@
*		len	Mő咷
*	out	SOCKET_ERROR:s  ȊO:M
*/ 
int	recv( SOCKET sn, byte *buf, int len )
{
	int	data_len, ret;

	data_len = getsn_rx_rsr((char)sn );	/* MTCY */
	if( data_len > 0 ){
		if( data_len > len ){		/* Mő傫 */
			data_len = len;
		}
		recv_data((char)sn, buf, data_len );
		setsn_cr((char)sn, Sn_CR_RECV );

		WAIT_ENDPROCESS((char)sn );	/* I҂ */
		ret = data_len;
	}
	else{
		ret = SOCKET_ERROR;
	}

	return	ret;
}


/**
*	f[^M(UDP,IP_RAW,MAC_RAW[h)
*	 in	sn	\Pbgԍ
*		buf	f[^obt@
*		len	f[^
*		addr	IPAhX
*		port	̃|[gԍ
*	out	SOCKET_ERROR:s  ȊO:Mf[^TCY
*/ 
int	sendto( SOCKET sn, byte *buf, int len, dword addr, word port )
{
	int	datalen, max;
	byte	ir;
	dword	ip;

	max = socksts[sn].txsize;
	if( len > max ){	/* obt@傫 */
		datalen = max;
	}
	else{
		datalen = len;
	}
	if(( addr == 0 ) || ( port == 0x00 ) || ( datalen == 0 )){/* sp[^ */
		datalen = SOCKET_ERROR;
	}
	else{
		setsn_destip((char)sn, addr );	/* IPAhX */
		setsn_destport((char)sn, port );	/* ̃|[g */

		send_data((char)sn, buf, datalen );	/* f[^M */

		WAIT_ENDPROCESS((char)sn );	/* I҂ */
		while( 1 ){
			ir = getsn_ir( (char)sn );
			if( ir & Sn_IR_SEND_OK ){	/* M */
				setsn_ir((char)sn, Sn_IR_SEND_OK );
				break;
			}
			else if( ir & Sn_IR_TIMEOUT ){	/* ^CAEg */
				setsn_ir((char)sn, Sn_IR_SEND_OK | Sn_IR_TIMEOUT );
				datalen = SOCKET_ERROR;
				break;
			}
		}
	}

	return	datalen;
}


/**
*	f[^M(UDP,IP_RAW,MAC_RAW[h)
*	 in	sn	\Pbgԍ
*		buf	f[^i[obt@
*		len	őf[^
*		addr	IPAhXi[(MACRAWNULLw)
*		port	̃|[gԍi[(IPRAW,MACRAWNULLw)
*	out	SOCKET_ERROR:s  ȊO:M
*/
int	recvfrom( SOCKET sn, byte *buf, int len, dword *addr, word *port )
{
	word	ptr;
	int	data_len, ret;
	char	d;

	data_len = ptr = 0;
	ptr = getsn_rx_rd( sn );	/* Mǂݏo|C^ */
	d = getsn_sr( sn );	/* vgR */
	if( d == SOCK_UDP ){	/* UDPM */
		{
			struct{	/* tco\ */
				dword	addr;	/* MIPAhX */
				word	port;	/* M|[g */
				word	length;	/*  */
			} head;
			read_data( sn, ptr, (byte *)&head, 8 );	/* wb_ǂݍ */
			*addr = ntohl( head.addr );
			*port = ntohs( head.port );
			data_len = ntohs( head.length );
			if( data_len > len ){
				data_len = len;
			}
			ptr += 8;
			read_data( sn, ptr, buf, data_len );	/* f[^ǂݏo */
			ptr += data_len;
			setsn_rx_rd( sn, ptr );	/* Mǂݏo|C^XV */
			ret = data_len;
		}
	}
	else if( d == SOCK_IPRAW ){	/* IPRAW */
		{
			struct{	/* IPRAW\ */
				dword	addr;	/* MIPAhX */
				word	length;	/*  */
			} head;

			read_data( sn, ptr, (byte *)&head, 6 );/* wb_ǂݍ */
			ptr += 6;
			*addr = ntohl( head.addr );
			data_len = ntohs( head.length );
			if( data_len > len ){
				data_len = len;
			}
			read_data( sn, ptr, buf, data_len );
			ptr += data_len;
			setsn_rx_rd( sn, ptr );	/* Mǂݏo|C^XV */
			ret = data_len;
		}
	}
	else if( d == SOCK_MACRAW ){	/* MACRAW */
		{
			word	length;	/*  */

			read_data( sn, ptr, (byte*)&length, 2 );
			ptr += 2;
			data_len = ntohs( length );
			if( data_len > len ){
				data_len = len;
			}
			read_data( sn, ptr, buf, data_len );
			ptr += data_len;
			setsn_rx_rd( sn, ptr );	/* Mǂݏo|C^XV */
			ret = data_len;
		}
	}
	else{
		ret = SOCKET_ERROR;
	}
	setsn_cr( sn, Sn_CR_RECV );	/* tONA */

	WAIT_ENDPROCESS( sn );

 	return	ret;
}


/* end of socket.c */
